// code for MOV instructions of Intel 8008
// no influence on flags
#include "MOV.h"
#include "main.h"


void mvi_a()
{
	Areg = memory(PC+1);
	PC += 2;
}

void mvi_b()
{
	Breg = memory(PC+1);
	PC += 2;
}

void mvi_c()
{
	Creg = memory(PC+1);
	PC += 2;
}

void mvi_d()
{
	Dreg = memory(PC+1);
	PC += 2;
}

void mvi_e()
{
	Ereg = memory(PC+1);
	PC += 2;
}

void mvi_h()
{
	Hreg = memory(PC+1);
	PC += 2;
}

void mvi_l()
{
	Lreg = memory(PC+1);
	PC += 2;
}

void mvi_m()
{
uint16_t addr;
	addr = Lreg | Hreg<<8;
	if ((addr>2047) && (addr<RAMTOP)) {
		KRam[addr] = memory(PC+1);	// K1000 specific: writable RAM only 4K starting at 2048
	}
	PC += 2;
}

void mov_aa()
{
	Areg = Areg;
	PC++;
}

void mov_ab()
{
	Areg = Breg;
	PC++;
}

void mov_ac()
{
	Areg = Creg;
	PC++;
}

void mov_ad()
{
	Areg = Dreg;
	PC++;
}

void mov_ae()
{
	Areg = Ereg;
	PC++;
}

void mov_ah()
{
	Areg = Hreg;
	PC++;
}

void mov_al()
{
	Areg = Lreg;
	PC++;
}

void mov_am()
{
	Areg = Mem;
	PC++;
}

void mov_ba()
{
	Breg = Areg;
	PC++;
}

void mov_bb()
{
	Breg = Breg;
	PC++;
}

void mov_bc()
{
	Breg = Creg;
	PC++;
}

void mov_bd()
{
	Breg = Dreg;
	PC++;
}

void mov_be()
{
	Breg = Ereg;
	PC++;
}

void mov_bh()
{
	Breg = Hreg;
	PC++;
}

void mov_bl()
{
	Breg = Lreg;
	PC++;
}

void mov_bm()
{
	Breg = Mem;
	PC++;
}

void mov_ca()
{
	Creg = Areg;
	PC++;
}

void mov_cb()
{
	Creg = Breg;	
	PC++;
}

void mov_cc()
{
	Creg = Creg;
	PC++;
}

void mov_cd()
{
	Creg = Dreg;
	PC++;
}

void mov_ce()
{
	Creg = Ereg;
	PC++;
}

void mov_ch()
{
	Creg = Hreg;
	PC++;
}

void mov_cl()
{
	Creg = Lreg;
	PC++;
}

void mov_cm()
{
	Creg = Mem;
	PC++;
}

void mov_da()
{
	Dreg = Areg;
	PC++;
}

void mov_db()
{
	Dreg = Breg;
	PC++;
}

void mov_dc()
{
	Dreg = Creg;
	PC++;
}

void mov_dd()
{
	Dreg = Dreg;
	PC++;
}

void mov_de()
{
	Dreg = Ereg;
	PC++;
}

void mov_dh()
{
	Dreg = Hreg;
	PC++;
}

void mov_dl()
{
	Dreg = Lreg;
	PC++;
}

void mov_dm()
{
	Dreg = Mem;
	PC++;
}

void mov_ea()
{
	Ereg = Areg;
	PC++;
}

void mov_eb()
{
	Ereg = Breg;
	PC++;
}

void mov_ec()
{
	Ereg = Creg;
	PC++;
}

void mov_ed()
{
	Ereg = Dreg;
	PC++;
}

void mov_ee()
{
	Ereg = Ereg;
	PC++;
}

void mov_eh()
{
	Ereg = Hreg;
	PC++;
}

void mov_el()
{
	Ereg = Lreg;
	PC++;
}

void mov_em()
{
	Ereg = Mem;
	PC++;
}

void mov_ha()
{
	Hreg = Areg;
	PC++;
}

void mov_hb()
{
	Hreg = Breg;
	PC++;
}

void mov_hc()
{
	Hreg = Creg;
	PC++;
}

void mov_hd()
{
	Hreg = Dreg;
	PC++;
}

void mov_he()
{
	Hreg = Ereg;
	PC++;
}

void mov_hh()
{
	Hreg = Hreg;
	PC++;
}

void mov_hl()
{
	Hreg = Lreg;
	PC++;
}

void mov_hm()
{
	Hreg = Mem;
	PC++;
}

void mov_la()
{
	Lreg = Areg;
	PC++;
}

void mov_lb()
{
	Lreg = Breg;
	PC++;
}

void mov_lc()
{
	Lreg = Creg;
	PC++;
}

void mov_ld()
{
	Lreg = Dreg;
	PC++;
}

void mov_le()
{
	Lreg = Ereg;
	PC++;
}

void mov_lh()
{
	Lreg = Hreg;
	PC++;
}

void mov_ll()
{
	Lreg = Lreg;
	PC++;
}

void mov_lm()
{
	Lreg = Mem;
	PC++;
}

void mov_ma()
{
uint16_t addr;
	addr = Lreg | Hreg<<8;
	if ((addr>2047) && (addr<RAMTOP)) {
		KRam[addr] = Areg;	// K1000 specific: writable RAM only 4K starting at 2048
	}
	PC++;
}

void mov_mb()
{
uint16_t addr;
	addr = Lreg | Hreg<<8;
	if ((addr>2047) && (addr<RAMTOP)) {
		KRam[addr] = Breg;	// K1000 specific: writable RAM only 4K starting at 2048
	}
	PC++;
}

void mov_mc()
{
uint16_t addr;
	addr = Lreg | Hreg<<8;
	if ((addr>2047) && (addr<RAMTOP)) {
		KRam[addr] = Creg;	// K1000 specific: writable RAM only 4K starting at 2048
	}
	PC++;
}

void mov_md()
{
uint16_t addr;
	addr = Lreg | Hreg<<8;
	if ((addr>2047) && (addr<RAMTOP)) {
		KRam[addr] = Dreg;	// K1000 specific: writable RAM only 4K starting at 2048
	}
	PC++;
}

void mov_me()
{
uint16_t addr;
	addr = Lreg | Hreg<<8;
	if ((addr>2047) && (addr<RAMTOP)) {
		KRam[addr] = Ereg;	// K1000 specific: writable RAM only 4K starting at 2048
	}
	PC++;
}

void mov_mh()
{
uint16_t addr;
	addr = Lreg | Hreg<<8;
	if ((addr>2047) && (addr<RAMTOP)) {
		KRam[addr] = Hreg;	// K1000 specific: writable RAM only 4K starting at 2048
	}
	PC++;
}

void mov_ml()
{
uint16_t addr;
	addr = Lreg | Hreg<<8;
	if ((addr>2047) && (addr<RAMTOP)) {
		KRam[addr] = Lreg;	// K1000 specific: writable RAM only 4K starting at 2048
	}
	PC++;
}
